## pybindgen 0.20.0%2Bdfsg1

=== examples/a/wscript ===
## -*- python -*-

def build(bld):
    ## manual code generation using simple pybindgen API calls
    gen = bld(
        features='command',
        source='modulegen.py',
        target='amodule.cc',
        command='${PYTHON} ${SRC[0]} > ${TGT[0]}')

    if bld.env['CXX']:
        obj = bld(features=['cxx', 'cxxshlib', 'pyext'])
        obj.source = [
            'a.cc',
            'amodule.cc'
            ]
        obj.target = 'a'
        obj.install_path = None # do not install
        obj.includes = '.'


    if bld.env['ENABLE_PYGCCXML']:
        ## gccxml direct generation method
        bld(
            features='command',
            source='module-autogen.py a.h',
            target='a1module.cc',
            command='${PYTHON} ${SRC[0]} ${SRC[1]} > ${TGT[0]}')

        obj = bld(features=['cxx', 'cxxshlib', 'pyext'])
        obj.source = [
            'a.cc',
            'a1module.cc'
            ]
        obj.target = 'a1'
        obj.install_path = None # do not install
        obj.includes = '.'


        ## gccxml indirect generation method
        bld(
            features='command',
            source='module-autoscan.py a.h',
            target='a2modulegen.py',
            command='${PYTHON} ${SRC[0]} ${SRC[1]} > ${TGT[0]}')

        bld(
            features='command',
            source='a2modulegen.py',
            target='a2module.cc',
            command='${PYTHON} ${SRC[0]} > ${TGT[0]}')

        obj = bld(features=['cxx', 'cxxshlib', 'pyext'])
        obj.source = [
            'a.cc',
            'a2module.cc'
            ]
        obj.target = 'a2'
        obj.install_path = None # do not install
        obj.includes = '.'

## pybindgen 0.20.0+dfsg1

=== wscript ===
## -*- python -*-
## (C) 2007-2014 Gustavo J. A. M. Carneiro

from wutils import get_version

from waflib import Options
from waflib import Build

from waflib import Scripting
Scripting.dist_format = 'zip'

from waflib import Configure

from waflib import Logs

import os
import subprocess
import shutil
import sys
import tarfile
import re
import types


APPNAME='pybindgen'
top = '.'
out = 'build'



## Add the pybindgen dir to PYTHONPATH, so that the examples and tests are properly built before pybindgen is installed.
if 'PYTHONPATH' in os.environ:
    os.environ['PYTHONPATH'] = os.pathsep.join([os.getcwd(), os.environ['PYTHONPATH']])
else:
    os.environ['PYTHONPATH'] = os.getcwd()


# http://coreygoldberg.blogspot.com/2009/07/python-zip-directories-recursively.html
def zipper(dir, zip_file, archive_main_folder=None):
    import zipfile
    zip = zipfile.ZipFile(zip_file, 'w', compression=zipfile.ZIP_DEFLATED)
    root_len = len(os.path.abspath(dir))
    for root, dirs, files in os.walk(dir):
        archive_root = os.path.abspath(root)[root_len:]
        for f in files:
            fullpath = os.path.join(root, f)
            archive_name = os.path.join(archive_root, f)
            if archive_main_folder is not None:
                if archive_name.startswith(os.sep):
                    n = archive_name[len(os.sep):]
                else:
                    n = archive_name
                archive_name = os.path.join(archive_main_folder, n)
            zip.write(fullpath, archive_name, zipfile.ZIP_DEFLATED)
    zip.close()



def options(opt):
    opt.load('python_patched', tooldir="waf-tools")
    opt.load('compiler_cc')
    opt.load('compiler_cxx')
    opt.load('cflags', tooldir="waf-tools")
    opt.recurse('examples')


    optgrp = opt.add_option_group("PyBindGen Options")

    optgrp.add_option('--examples',
                      help=('Compile the example programs.'),
                      action="store_true", default=False,
                      dest='examples')

    optgrp.add_option('--disable-pygccxml',
                      help=('Disable pygccxml for unit tests / examples.'),
                      action="store_true", default=False,
                      dest='disable_pygccxml')

    optgrp.add_option('--valgrind',
                      help=('Run unit tests through valgrind.'),
                      action="store_true", default=False,
                      dest='valgrind')



def _check_compilation_flag(conf, flag, mode='cxx', linkflags=None):
    """
    Checks if the C++ compiler accepts a certain compilation flag or flags
    flag: can be a string or a list of strings
    """
    l = []
    if flag:
        l.append(flag)
    if isinstance(linkflags, list):
        l.extend(linkflags)
    else:
        if linkflags:
            l.append(linkflags)
    if len(l) > 1:
        flag_str = 'flags ' + ' '.join(l)
    else:
        flag_str = 'flag ' + ' '.join(l)
    if len(flag_str) > 28:
        flag_str = flag_str[:28] + "..."

    conf.start_msg('Checking for compilation %s support' % (flag_str,))
    env = conf.env.derive()

    if mode == 'cc':
        mode = 'c'

    if mode == 'cxx':
        fname = 'test.cc'
        env.append_value('CXXFLAGS', flag)
    else:
        fname = 'test.c'
        env.append_value('CFLAGS', flag)

    if linkflags is not None:
        env.append_value("LINKFLAGS", linkflags)

    try:
        retval = conf.run_c_code(code='#include <stdio.h>\nint main() { return 0; }\n',
                                 env=env, compile_filename=fname,
                                 features=[mode, mode+'program'], execute=False)
    except conf.errors.ConfigurationError:
        ok = False
    else:
        ok = (retval == 0)
    conf.end_msg(ok)
    return ok


# starting with waf 1.6, conf.check() becomes fatal by default if the
# test fails, this alternative method makes the test non-fatal, as it
# was in waf <= 1.5
def _check_nonfatal(conf, *args, **kwargs):
    try:
        return conf.check(*args, **kwargs)
    except conf.errors.ConfigurationError:
        return None


def configure(conf):

    conf.check_compilation_flag = types.MethodType(_check_compilation_flag, conf)
    conf.check_nonfatal = types.MethodType(_check_nonfatal, conf)

    conf.load('command', tooldir="waf-tools")
    conf.load('python_patched', tooldir="waf-tools")
    conf.check_python_version((2,3))

    try:
        conf.load('compiler_cc')
        conf.load('compiler_cxx')
    except conf.errors.ConfigurationError:
        Logs.warn("C/C++ compiler not detected.  Unit tests and examples will not be compiled.")
        conf.env['CXX'] = ''
    else:
        conf.load('cflags')
        conf.check_python_headers()

        if not Options.options.disable_pygccxml:
            castxml = conf.find_program('castxml', mandatory=False)
            gccxml = conf.find_program('gccxml', mandatory=False)
            if not (gccxml or castxml):
                conf.env['ENABLE_PYGCCXML'] = False
            else:
                try:
                    conf.check_python_module('pygccxml')
                except conf.errors.ConfigurationError:
                    conf.env['ENABLE_PYGCCXML'] = False
                else:
                    conf.env['ENABLE_PYGCCXML'] = True
                    if castxml:
                        conf.env['PYGCCXML_MODE'] = 'castxml'
                    else:
                        conf.env['PYGCCXML_MODE'] = 'gccxml'

        # -fvisibility=hidden optimization
        if (conf.env['CXX_NAME'] == 'gcc' and [int(x) for x in conf.env['CC_VERSION']] >= [4,0,0]
            and conf.check_compilation_flag('-fvisibility=hidden')):
            conf.env.append_value('CXXFLAGS_PYEXT', '-fvisibility=hidden')
            conf.env.append_value('CCFLAGS_PYEXT', '-fvisibility=hidden')

        # Add include path for our stdint.h replacement, if needed (pstdint.h)
        if not conf.check_nonfatal(header_name='stdint.h'):
            conf.env.append_value('CPPPATH', os.path.join(conf.curdir, 'include'))

    if conf.check_nonfatal(header_name='boost/shared_ptr.hpp'):
        conf.env['ENABLE_BOOST_SHARED_PTR'] = True

    conf.recurse('benchmarks')
    conf.recurse('examples')


def build(bld):
    bld.recurse('pybindgen')

    if bld.cmd == 'check':
        bld.recurse('tests')

    if Options.options.examples:
        bld.recurse('examples')

    if 0: # FIXME

        if Options.commands.get('bench', False) or Options.commands['clean']:
            bld.recurse('benchmarks')


check_context = Build.BuildContext
def bench(bld):
    "run the benchmarks; requires many tools, used by maintainers only"
    Scripting.build(bld)
    env = g_bld.env

    print("Running benchmarks...")
    retval = subprocess.Popen([env['PYTHON'], '-O', 'benchmarks/bench.py',
                               "build/default/benchmarks/results.xml", ' '.join(env['CXXFLAGS_PYEXT'] + env['CXXFLAGS'])]).wait()
    if retval:
        raise SystemExit(retval)

    print("Generating benchmarks report...")
    retval = subprocess.Popen([env['PYTHON'], '-O', 'benchmarks/plotresults.py',
                               "build/default/benchmarks/results.xml",
                               "build/default/benchmarks/results"]).wait()
    if retval:
        raise SystemExit(retval)


from waflib import Context, Build, Scripting
class CheckContext(Context.Context):
    """run the unit tests"""
    cmd = 'check'

    def execute(self):

        # first we execute the build
        bld = Context.create_context("build")
        bld.options = Options.options # provided for convenience
        bld.cmd = "check"
        bld.execute()


        if Options.options.verbose:
            verbosity = ['-v']
        else:
            verbosity = []

        if Options.options.valgrind:
            valgrind = ['valgrind', '--leak-check=full', '--leak-resolution=low']
        else:
            valgrind = []

        print("Running pure python unit tests...")
        python = bld.env['PYTHON'][0]
        retval1 = subprocess.Popen([python, 'tests/test.py'] + verbosity).wait()

        env = bld.env

        retvals = []

        if env['CXX']:
            print("Running manual module generation unit tests (module foo)...")
            retvals.append(subprocess.Popen(valgrind + [python, 'tests/footest.py', '1', 'none'] + verbosity).wait())
        else:
            print("Skipping manual module generation unit tests (no C/C++ compiler)...")

        if env['ENABLE_PYGCCXML']:
            print("Running automatically scanned module generation unit tests (module foo2)...")
            retvals.append(subprocess.Popen(valgrind + [python, 'tests/footest.py', '2', env['PYGCCXML_MODE']] + verbosity).wait())

            print("Running module generated by automatically generated python script unit tests (module foo3)...")
            retvals.append(subprocess.Popen(valgrind + [python, 'tests/footest.py', '3', env['PYGCCXML_MODE']] + verbosity).wait())

            print("Running module generated by generated and split python script unit tests  (module foo4)...")
            retvals.append(subprocess.Popen(valgrind + [python, 'tests/footest.py', '4', env['PYGCCXML_MODE']] + verbosity).wait())

            print("Running semi-automatically scanned c-hello module ('hello')...")
            retvals.append(subprocess.Popen(valgrind + [python, 'tests/c-hello/hellotest.py'] + verbosity).wait())
        else:
            print("Skipping automatically scanned module generation unit tests (pygccxml missing)...")
            print("Skipping module generated by automatically generated python script unit tests (pygccxml missing)...")
            print("Skipping module generated by generated and split python script unit tests  (pygccxml missing)...")
            print("Skipping semi-automatically scanned c-hello module (pygccxml missing)...")

        if env['ENABLE_BOOST_SHARED_PTR']:
            print("Running boost::shared_ptr unit tests...")
            retvals.append(subprocess.Popen(valgrind + [python, 'tests/boost/bartest.py'] + verbosity).wait())
        else:
            print("Skipping boost::shared_ptr unit tests (boost headers not found)...")

        if any(retvals):
            Logs.error("Unit test failures")
            raise SystemExit(2)



class DistContext(Scripting.Dist):

    cmd = 'dist'
    def get_base_name(self):
        srcdir = '.'
        version = get_version(srcdir)
        return "pybindgen-" + version


    def execute(self):
        blddir = './build'
        srcdir = '.'
        subprocess.Popen(["python", os.path.join(srcdir, "setup.py"), "clean"]).wait()
        version = get_version(srcdir)
        subprocess.Popen([os.path.join(srcdir, "generate-ChangeLog")],  shell=True).wait()
        try:
            os.chmod(os.path.join(srcdir, "ChangeLog"), 0o644)
        except OSError:
            pass

        ## Package the api docs in a separate tarball

        # generate the docs first
        r = subprocess.Popen(["make", "html"], cwd='doc').wait()
        if r:
            raise SystemExit(r)

        apidocs = 'apidocs'
        if not os.path.isdir('doc/_build/html'):
            Logs.warn("Not creating docs archive: the `doc/_build/html' directory does not exist")
        else:
            zipper('doc/_build/html', "pybindgen-%s-docs.zip" % version)


        try:
            os.unlink('waf-light')
        except OSError:
            pass

        super(DistContext, self).execute() # -----------------------------

    def get_excl(self):
        return super(DistContext, self).get_excl() + ' *.zip doc/_build .shelf *.pstat'



def docs(ctx):
    "generate API documentation, using epydoc"
    retval = subprocess.Popen(["make", "html"], cwd='doc').wait()
    if retval:
        Logs.error("make returned with code %i" % retval)
        raise SystemExit(2)

=== examples/wscript ===
## -*- python -*-

def options(opt):
    pass#opt.tool_options('boost')

def build(bld):
    bld.recurse('a b c d e f g h')
    bld.recurse('callback')
    #bld.recurse('buffer') # doesn't work on python3
    if bld.env['ENABLE_BOOST_SHARED_PTR']:
        bld.recurse('boost_shared_ptr')
    bld.recurse('import_from_module')

    if bld.env["ENABLE_CXX11"]:
    	bld.recurse('std_shared_ptr')

def configure(conf):
	if conf.check_compilation_flag('-std=c++11'):
		conf.env["ENABLE_CXX11"] = True

=== examples/b/wscript ===
## -*- python -*-

def build(bld):

    gen = bld(
        features='command',
        source='modulegen.py',
        target='bmodule.cc',
        command='${PYTHON} ${SRC[0]} > ${TGT[0]}')

    if bld.env['CXX']:
        obj = bld(features=['cxx', 'cxxshlib', 'pyext'])
        obj.source = [
            'b.cc',
            'bmodule.cc'
            ]
        obj.target = 'b'
        obj.install_path = None # do not install
        obj.includes = '.'

=== examples/h/wscript ===
## -*- python -*-

def build(bld):

    gen = bld(
        features='command',
        source='modulegen.py',
        target='hmodule.cc',
        command='${PYTHON} ${SRC[0]} > ${TGT[0]}')

    if bld.env['CXX']:
        obj = bld(features=['cxx', 'cxxshlib', 'pyext'])
        obj.source = [
            'h.cc',
            'hmodule.cc'
            ]
        obj.target = 'h'
        obj.install_path = None # do not install
        obj.includes = '.'

=== debian/changelog ===
pybindgen (0.20.0+dfsg1-5) unstable; urgency=medium

  * Team upload.
  * Port to Sphinx 8.0 (closes: #1090117).

 -- Colin Watson <cjwatson@debian.org>  Fri, 20 Dec 2024 18:04:07 +0000

pybindgen (0.20.0+dfsg1-4) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Wed, 16 Nov 2022 10:27:19 +0000

pybindgen (0.20.0+dfsg1-3) unstable; urgency=medium

  [ Ondřej Nový ]
  * Use 'python3 -m sphinx' instead of sphinx-build for building docs.
  * d/control: Update Maintainer field with new Debian Python Team
    contact address.
  * d/control: Update Vcs-* fields with new Debian Python Team Salsa
    layout.

  [ Debian Janitor ]
  * Apply multi-arch hints.
    + python-pybindgen-doc: Add Multi-Arch: foreign.
  * Update standards version to 4.5.0, no changes needed.
  * Bump debhelper from old 12 to 13.
  * Update standards version to 4.5.1, no changes needed.

 -- Sandro Tosi <morph@debian.org>  Thu, 02 Jun 2022 20:58:40 -0400

pybindgen (0.20.0+dfsg1-2) unstable; urgency=medium

  [ Sophie Brun ]
  * Team upload.
  * Fix upstream license: LGPL-2+ mentioned in setup.py

  [ Raphaël Hertzog ]
  * Bump Standards-Version to 4.4.1
  * Source only upload to let it migrate to testing...

 -- Raphaël Hertzog <raphael@offensive-security.com>  Fri, 18 Oct 2019 15:00:42 +0200

pybindgen (0.20.0+dfsg1-1) unstable; urgency=medium

  * Initial release (Closes: #940567)

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 27 Aug 2019 16:37:56 +0200

=== debian/control ===
Source: pybindgen
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Sophie Brun <sophie@offensive-security.com>
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 python3-all,
 python3-setuptools,
 python3-setuptools-scm,
 python3-sphinx
Standards-Version: 4.6.1
Homepage: https://github.com/gjcarneiro/pybindgen
Vcs-Browser: https://salsa.debian.org/python-team/packages/pybindgen
Vcs-Git: https://salsa.debian.org/python-team/packages/pybindgen.git
Testsuite: autopkgtest-pkg-python

Package: python3-pybindgen
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Suggests: python-pybindgen-doc
Description: Python bindings generator (Python 3)
 This package contains a Python bindings generator. It can generate clean C or
 C++ code or self contained code.
 .
 This package installs the library for Python 3.

Package: python-pybindgen-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Multi-Arch: foreign
Description: Python bindings generator (common documentation)
 This package contains a Python bindings generator. It can generate clean C or
 C++ code or self contained code.
 .
 This is the common documentation package.

=== debian/rules ===
#!/usr/bin/make -f
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export PYBUILD_NAME=pybindgen

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build
	PYTHONPATH=. http_proxy='127.0.0.1:9' python3 -m sphinx -N -bhtml doc/ build/html # HTML generator

=== debian/watch ===
version=4
# PyPI
opts="dversionmangle=s/\+dfsg\d*$// ,repacksuffix=+dfsg1" \
https://pypi.debian.net/PyBindGen/PyBindGen-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
